/* asteroid.c 
   Statistiche elementari su un catalogo di asteroidi
  */
#include <stdio.h>
#include <math.h>
/* 
   Prototipi delle funzioni
*/
long leggi_dati(FILE *in);
/* 
   Area destinata a contenere i dati
*/
#define NDATMX 20000
struct {
  char  id[28];
  int   ln;
  float dper;
  float dfel;
  long  epoc;
  float anom;
  float peri;
  float nodo;
  float incl;
  float ecce;
  float semi;
}  ast[NDATMX];
/*  */
int main()
{
  FILE *in;
  long int j,ndat;
				/* Apertura del file in lettura */
  if((in = fopen("aster.dat","r")) == NULL) {
    printf("Errore nell'apertura del file in lettura:\n","aster.dat");
    perror("aster.dat");
  }
  ndat = leggi_dati(in);		/* Porto in memoria i dati */
  fclose(in);
  for(j=0;j<ndat;j++)
    printf("%s%1d%8.3f%8.3f%11d%8.2f%7.1f%7.1f%7.1f%7.3f%8.3f\n",
	   ast[j].id,
	   ast[j].ln,
	   ast[j].dper,
	   ast[j].dfel,
	   ast[j].epoc,
	   ast[j].anom,
	   ast[j].peri,
	   ast[j].nodo,
	   ast[j].incl,
	   ast[j].ecce,
	   ast[j].semi);
  return(0);
}
/*  */
long leggi_dati(in)
     FILE *in;
{
  long j=0;
  int i;
  char riga[256];
  fgets(riga,256,in);		/* Salta le prime due righe */
  fgets(riga,256,in); 
				/* e leggi il resto */
  while(fgets(riga,256,in) != NULL) {
    for(i=0;i<24;i++) ast[j].id[i]=riga[i];
    ast[j].id[24] = '\000';
    sscanf(riga+24,"%d%f%f%d%f%f%f%f%f%f\n",
	   &ast[j].ln,
	   &ast[j].dper,
	   &ast[j].dfel,
	   &ast[j].epoc,
	   &ast[j].anom,
	   &ast[j].peri,
	   &ast[j].nodo,
	   &ast[j].incl,
	   &ast[j].ecce,
	   &ast[j].semi);
    ++j;
  }
  return(j);
}


