/* Funzioni di gestione delle stringhe di caratteri */
				/* Restituisce la lunghezza della stringa str */
int lunghezza_stringa(str)
     char *str;
{
  int j;
  for(j=0; str[j]!='\000';j++);
  return(j);
}
				/* Determina la posizione del carattere c nella 
				   stringa str. Se il carattere non c'e' 
				   restituisce la lunghezza della stringa */
int cerca_carattere(str,c)
     char str[];
     char c;
{
  int j;
  for(j=0; str[j]!='\000' && str[j]!=c; j++);
  return(j);
}
				/* Copia la stringa str_in nella stringa str_out;
				   restituisce il numero di caratteri copiati */
int copia_stringa(str_in,str_out)
     char str_in[],str_out[];
{
  int j;
  for(j=0; (str_out[j]=str_in[j])!='\000'; j++);
  return(j);
}
				/* Elimina i caratteri di spaziatura dalla 
				   stringa str. 
				   Restituisce il numero di caratteri rimasti. */
int elimina_spazi(str)
     char str[];
{
  int j,k;
  for(j=k=0; str[j] != '\000'; j++) {
    if(str[j] != '\040' && str[j] != '\012' && str[j] != '\010')
      str[k++] = str[j];
  }
  str[k] = '\000';
  return(k);
}
				/* Converte i caratteri alfabetici in maiuscolo.
				   Restituisce il numero di caratteri convertiti */
int conv_maiuscolo(str)
     char str[];
{
  int j,k;
  for(j=k=0; str[j] != '\000'; j++) {
    if(str[j] >= 'a' && str[j] <= 'z') {
      str[j] -= 32;
      k++;
    }
  }
    return(k);
}
				/* Converte i caratteri alfabetici in minuscolo.
				   Restituisce il numero di caratteri convertiti */
int conv_minuscolo(str)
     char str[];
{
  int j,k;
  for(j=k=0; str[j] != '\000'; j++) {
    if(str[j] >= 'A' && str[j] <= 'Z') {
      str[j] += 32;
      k++;
    }
  }
    return(k);
}
				/* Inverte una stringa di caratteri.  
				   Restituisce la lunghezza della stringa. */
int inverti_stringa(str)
     char str[];
{
  int j,n,ls;
  char tmp;
  n = ls = lunghezza_stringa(str);
  for(j=0; j<n; j++) {
    tmp = str[j];
    str[j] = str[--n];
    str[n] = tmp;
  }
  return(ls);
}
				/* Confronta due stringhe di caratteri
				   secondo l'ordine lessicografico
				   determinato dal codice ASCII; restituisce: 
				   -1 se la prima stringa precede la seconda; 
				    0 se le stringhe sono identiche; 
				    1 se la seconda stringa precede la prima.  */
int confronta_stringhe(str_1,str_2)
     char str_1[],str_2[];
{
  int j,risp;
  for(j=0; str_1[j]!='\000' && str_2[j]!='\000'; j++) {
    if(str_1[j] < str_2[j]) return(-1);
    else if (str_1[j] > str_2[j]) return(1);
  }
  if(str_1[j] != '\000') return(1);
  else if(str_1[j] != '\000') return(-1);
  else return(0);
}
