/* statcar.c 
   Statistiche varie sulle parole di un testo.
  */
#include <stdio.h>
#include <math.h>
#define NUL '\000'
/* 
   Prototipi delle funzioni
*/
long leggi_testo(FILE *in);
void freqcar(long ncar);
void lunparole(long ncar);
void corrcar(long ncar);
/* 
   Area destinata a contenere il testo
*/
#define NCARMX 2000000L
unsigned char testo[NCARMX];
/*  */
int main()
{
  FILE *in;
  long int j,ncar;
  char nomfil[256];
				/* Apertura del file in lettura */
  j=0;
 vai:
  printf("Dimmi che file devo esaminare: ");
  scanf("%s",nomfil);
  if((in = fopen(nomfil,"r")) == NULL) {
    ++j;
    printf("Errore nell'apertura del file in lettura:\n");
    perror(nomfil);
    if(j<3)  goto vai;
    else {
      printf("Hai sbagliato per tre volte. Vergognati!\n");
      return(-1);
    }
  }
  ncar = leggi_testo(in);		/* Porto in memoria il testo */
  fclose(in);
  printf("\nFrequenza dei caratteri\n");
  freqcar(ncar);		/* Frequenza dei caratteri */
  printf("\nLunghezza delle parole\n");
  lunparole(ncar);		/* Lunghezza delle parole */
  printf("\nCorrelazione tra i caratteri\n");
  corrcar(ncar);		/* Correlazione tra i caratteri */
  return(0);
}
/*  */
long leggi_testo(in)
     FILE *in;
{
  long j=0;
  while(fread(testo+j,sizeof(char),1,in) != 0) ++j;
  return(j);
}
/*  */
void freqcar(ncar)
     long ncar;
{
  long j,tot,cont[26];
  double percen;
  unsigned char i;
				/* Riempimento tabella contatori */
  for(j=0;j<26;cont[j++]=0);
  for(j=tot=0;j<ncar;j++) {
    if(testo[j]!=NUL) {
      if(testo[j] < 'A' || testo[j] > 'Z') {
	printf("Ho trovato un carattere inaspettato: codice ottale '\\%03o'.\n",
	       testo[j]);
	return;
      }
      ++cont[testo[j]-'A'];
      ++tot;
    }
  }
				/* Stampa della statistica */
  printf("Trovati %ld caratteri alfabetici.\n",tot);
  for(i='A';i<='Z';i++) {
    j = i-'A';
    percen = 100.*((double) cont[j])/((double) tot);
    printf("  %c   %10ld   %7.2f\n",i,cont[j],percen);
  }
  return;
}
/*  */
#define LUNMX 20
void lunparole(ncar)		/* Lunghezza delle parole */
     long ncar;
{
				/* cont[j] conta le parole con j caratteri;
				   cont[0] conta le parole con piu' di LUNMX caratteri */
  long j,l,tot,cont[LUNMX+1];
  double percen;
  for(j=0;j<=LUNMX;cont[j++]=0);
				/* Riempio la tabella dei contatori */
  for(j=l=tot=0;j<ncar;j++) {
    if(testo[j] == NUL) {
      if(l>LUNMX) l=0;
      ++cont[l];
      ++tot;
      l=0;
    }
    else if(testo[j]>='A' && testo[j]<='Z')
      ++l;
    else {
      printf("Ho trovato un carattere inaspettato: codice ottale '\\%03o'.\n",
	     testo[j]);
      return;
    }
  }
				/* Stampo i risultati */
  printf("Esaminate %ld parole.\n",tot);
  for(l=1;l<=LUNMX;l++) {
    percen = 100.*((double) cont[l])/((double) tot);
    printf("   %3ld   %10ld   %6.2f\n",l,cont[l],percen);
  }
  percen = 100.*((double) cont[0])/((double) tot);
  printf("  >%3d   %10ld   %6.2f\n",LUNMX,cont[0],percen);
  return;
}
/*  */
void corrcar(ncar)		/* Correlazione tra i caratteri */
     long ncar;
{				/* tabcar[k] e' il k-esimo carattere; 
				   tabcar[0] e' lo spazio (separatore di parola)
				   tabcar[1] e' il carattere 'A',
				   ...
				   tabcar[26] e' il carattere 'Z'.
				   corr[j][k] conta quante volte il carattere 
				   tabcar[k] segue tabcar[j]. 
				   totcor[j] e' la somma dei conteggi sulla riga corr[j]
*/
  long corr[27][27],totcor[27];
  long j,l,k;
  double percen;
  char tabcar[27];
  for(j=0;j<27;j++) {
    tabcar[j]='A'+j-1;
    totcor[j]=0;
    for(k=0;k<27;corr[j][k++]=0);
  }
  tabcar[0]=' ';
				/* Riempio le tabelle */
  for(l=j=0;l<ncar;l++){
    if(testo[l] == NUL)
      k = 0;
    else if(testo[l]>='A' && testo[l]<='Z') 
      k = testo[l]-'A'+1;
    else {
      printf("Ho trovato un carattere inaspettato: codice ottale '\\%03o'.\n",
	     testo[l]);
      return;
    }
    ++corr[j][k];
    ++totcor[j];
    j=k;
  }
				/* Stampa dei risultati; stampo 9 colonne per volta */
  for(l=0;l<27;l+=9) {
    printf("\n\n     |");
    for(k=0;k<9;k++)
      printf("   %c   |",tabcar[k+l]);
    printf("\n");
    for(j=0;j<27;j++) {
      printf("\n  %c  |",tabcar[j]);
      for(k=0;k<9;k++) {
	if(totcor[j] > 0)
	  percen = 100.*((double) corr[j][k+l])/((double) totcor[j]);
	else
	  percen=0.;
	printf("%6.2f |",percen);
      }
    }
    printf("\n");
  }
  return;
}
